#!/usr/bin/perl

#=====================================================================
# 作成
#=====================================================================
#   名    称: RSS reader Type1 Ver170
#   作成者: CANDY CGI
#   作成者サイト: http://www.candy-cgi.com/

#=====================================================================
#　設定の変更【ここから】
#=====================================================================
#■このファイルの先頭の１行のperlのパスを指定してください。（「#!/usr/local/bin/perl」や『#!/usr/bin/perl』など）
#「#!」の前には、空文字や空行や他の文字が入らないようにしてください。

#■表示件数　10件の場合は'10'　取得した全てを表示する場合は'0'
$max = '0';

#■RSSを取得する間隔を分で指定　15分の場合は'15'
$check = '15';

#■Newマークをつける時間　24時間以内に配信された記事にNewマークをつける場合は'24' Newマークを使わない場合は'0'
$new = '24';

#■読み込むRSSのURL　複数設定する場合は『,』で区切ってください　例('http://アドレス','http://アドレス')
@url = ('https://tky23annex.blog.ss-blog.jp/index.rdf');

#■各記事ごとにブログ名やサイト名などを表示したい場合、New!マークのデザインを変更したい場合は、下部の"■各記事の表記部分デザイン"を変更してください

########################################################################
#■文字数制限
#・表示する文字数　50文字の場合は'50'　全部表示する場合は'0'
########################################################################
#■ブログ名
$site_nagasa = '0';

#■記事タイトル
$title_nagasa = '0';

#■記事の説明(記事の要約)
$kiji_nagasa = '0';

####################################################################
# ■NG設定
# ・指定された文字が含まれていると表示しません　例('ero','出会い系')
# ・必要ない場合は()
####################################################################
#■ブログ名
@dels_tit = ();

#■ブログURL
@dels_lin = ();

#■記事タイトル
@deltit = ();

#■記事の説明(要約)
@delkiji = ();

#■記事URL
@dellin = ();

#=====================================================================
#　設定の変更【ここまで】
#=====================================================================

$file = 'log.cgi';
unless( -e "$file" ){open FH, ">$file";}

use XML::FeedPP;
use HTTP::Date;
use Encode;

$time = time;
$check = $check * 60;
$new_xp = $new * 3600;

open(IN,"<$file");
eval{flock(IN, 2);};
@main = <IN>;
close(IN);

chomp($main[0]);
$log_t = $main[0] + $check;

if($log_t <= $time){
foreach $xxx (@url) {
$feed = "";

eval{
local $SIG{ALRM} = sub {die "timeout"};
alarm 3;
$feed = XML::FeedPP->new($xxx);
};
alarm 0;
if ($@) {next;}

@list = $feed->get_item();

foreach $item (@list) {
my $site_t = $feed->title;
my $site_l = $feed->link;
my $title = $item->title;
my $link = $item->link;
my $des = $item->description;
my $tix = $item->pubDate;
   $tix = str2time($tix);

&tag($site_t);
&tag($site_l);
&tag($title);
&tag($link);
&tag($des);
&tag($tix);

$next = "0";
for(@dels_tit){if($site_t =~ /$_/i){$next="1"; last;}}
for(@dels_lin){if($site_l =~ /$_/i){$next="1"; last;}}
for(@deltit){if($title =~ /$_/i){$next="1"; last;}}
for(@dellin){if($link =~ /$_/i){$next="1"; last;}}
for(@delkiji){if($des =~ /$_/i){$next="1"; last;}}
if($next eq "1"){next;}

$text = $site_t;
$length = length(decode('utf-8', $text));
if ($site_nagasa ne "0" && $length > $site_nagasa) {$site_t = Encode::encode_utf8(substr(Encode::decode_utf8($site_t), 0, $site_nagasa)); $site_t = $site_t ."...";}

$text = $title;
$length = length(decode('utf-8', $text));
if ($title_nagasa ne "0" && $length > $title_nagasa) {$title = Encode::encode_utf8(substr(Encode::decode_utf8($title), 0, $title_nagasa)); $title = $title ."...";}

$text = $des;
$length = length(decode('utf-8', $text));
if ($kiji_nagasa ne "0" && $length > $kiji_nagasa) {$des = Encode::encode_utf8(substr(Encode::decode_utf8($des), 0, $kiji_nagasa)); $des = $des ."...";}

unshift @inp, "$tix<>$title<>$link<>$des<>$site_t<>$site_l\n";
}
}

$xx = @inp;
if(0 < $xx){
@sortinp = sort { (split(/<>/,$b))[0] <=> (split(/<>/,$a))[0] } @inp;
if ($max ne "0"){splice @sortinp, $max;}
unshift @sortinp, "$time\n";

open(OUT,"+< $file");
eval{flock(OUT, 2);};
eval{truncate(OUT, 0);};
seek(OUT, 0, 0);
print OUT @sortinp;
eval{flock(OUT, 8);};
close(OUT);
}
}

open(IN,"<$file");
eval{flock(IN, 2);};
@log = <IN>;
close(IN);

shift(@log);

print "Content-type: text/html; charset=utf-8\n\n";
print <<EOM; 
<html lang="ja"><head>
<meta http-equiv="Content-type" content="text/html; charset=UTF-8">
<title>RSS</title>
<meta http-equiv="content-style-type" content="text/css">
<link rel="stylesheet" href="style.css" type="text/css">
</head><body>
EOM

for(@log){ 
chomp $data;
my ($timex,$titlex,$linkx,$kiji,$s_title,$s_link) = split(/<>/, $_);

($sec,$min,$hour,$mday,$mon,$year,$wno) = localtime($timex);
@wdays = ('日','月','火','水','木','金','土');
$year = $year + 1900;
$year = substr($year,2,2);
#時間表示
my $timex_sp = sprintf("%02d/%02d/%02d(%s)",$year,$mon+1,$mday,$wdays[$wno],$hour,$min);
my $txp = $timex + $new_xp;

#　■各記事の表記部分デザイン
#  $timex_spで時間、$linkxで記事URL、$titlexで記事タイトルを表示しています。
#  $s_titleでブログ名、$s_linkでブログのURL、$kijiで記事の説明(要約)を追加表示できます。
#
#  ※表示部分の前後にある『print <<EOM;』の行と『EOM』の行は重要な部分なので変更しないでください。
###########################################################
#記事部分
###########################################################
print <<EOM;
$timex_sp  <br><a href="$linkx" target="_blank">$titlex</a>
EOM
###########################################################
#
#
if($new ne "0" && $time <= $txp){
###########################################################
#Newマーク
###########################################################
print <<EOM;
<span class="new">New!</span>
EOM
###########################################################
}

print "<br>\n";
}

print "</body></html>";
exit;

sub tag{ 
$_[0] =~ s/\r\n/<br>/g;
$_[0] =~ s/\r/<br>/g;
$_[0] =~ s/\n/<br>/g;
$_[0] =~ s/<.*?>//g;
$_[0] =~ s/</&lt;/g; 
$_[0] =~ s/>/&gt;/g; 
}
